//*****************************************************************************
//
// Имя файла    : 'core.cpp'
// Описание     : Интерфейс взаимодействия с ядром
// Автор        : Межлумов В.Ш.
//
//*****************************************************************************

#include "core.h"
#include "factory.h"
#include "defines.h"


// ============================================================================
///
///                             Конструктор
///
// ============================================================================

CCore::CCore () :
    QObject()
{
}


// ============================================================================
///
///                             Деструктор
///
// ============================================================================

CCore::~CCore ()
{
}


// ============================================================================
///                             Инициализация
// ============================================================================
/// \param  argc    Количество параметров
/// \param  argv    Список параметров приложения
// ============================================================================

void CCore::Init (int& argc, char** argv)
{
    QCoreApplication::setOrganizationName(APP_ORGANIZATION);
    QCoreApplication::setApplicationName(APP_SHORT_TITLE);
    QCoreApplication::setOrganizationDomain("ru");
    QCoreApplication::setApplicationVersion(APP_VERSION);

    // Создание объекта приложения Qt
    // Параметры argc и argv должны существовать на протяжении всего времени жизни объекта QApplication
    m_app = new QApplication(argc, argv);

    // Установка пути для поиска библиотек
    QCoreApplication::addLibraryPath( QCoreApplication::applicationDirPath() );

    // Инициализация менеджера плагинов
    CPluginMgr* mgr = CFactory::GetPluginMgr();
    mgr->Init();
}


// ============================================================================
///                             Запуск приложения
// ============================================================================
/// \return     Код результата завершения приложения
// ============================================================================

int CCore::Run (void)
{
    // Отображение GUI
    CFactory::GetGui()->Show();

    // Запуск приложения
    return m_app->exec();
}
